//************************************************************************
// Program Name	: Read ALL the numbers from and file and Prints it on Screen.
// Programmer	: Petros Panayi	Stud. ID: 000000
// Date  Modif.	: 1 Sep 2017
//************************************************************************
// Comments: Read ALL the numbers from and file and Prints it on Screen.
// Stack Frame:
//				|-----------------------|
//	  			|						|
//		sp'-->	|-----------------------|
//	  			|			&a			|
//				|-----------------------|<-- fp + 28
//	  			|						|
//				|-----------------------|<-- fp + 24
//	  			|						|
//				|-----------------------|
//	  			|						|
//				|-----------------------|
//	  			|	 *** x30 = lr'	***	|
//				|-----------------------|
//	  			|	*** x30 = lr'	***	|
//				|-----------------------|<-- fp + 8
//	  			|		X29 = fp'		|
//				|-----------------------|
//	  			|		X29 = fp'		|
//sp=sp'-32 -->	|-----------------------| <-- fp
//	  			|						|
//				|-----------------------|
//	  			|						|
//				|-----------------------|
//	  			|						|
//				|-----------------------|
//	  			|						|
//************************************************************************
//References:
//http://www.cplusplus.com/reference/cstdio/fopen/
//http://www.cplusplus.com/reference/cstdio/fscanf/
//http://www.cplusplus.com/reference/cstdio/fclose/
//http://www.cplusplus.com/reference/cstdio/feof/
//************************************************************************

.data
FileOpenMode: 	.string	"r"
FileName: 	.string	"test.txt"
fscanf_str: .string	"%d"
printf_str: .string	"%d "
	.text
	.global	main

main:

	stp	x29, x30, [sp, -32]!
	add	x29, sp, 0

	// Open the File Pointer
	adr	x1, FileOpenMode
	adr	x0, FileName
	bl	fopen
	mov x20, x0			// Store the file pointer into X20

loop:
	add	x2, x29, 28		// The Location that fscanf will store the value
	adr	x1, fscanf_str
	mov	x0, x20			// The File pointer
	bl	fscanf
	ldr	w1, [x29, 28]	// Get the value from the stack
	adr	x0, printf_str
	bl	printf			// Print the value on the screen
	mov	x0, x20			// The File pointer
	bl	feof			// feof will return !=0 on EndOfFile
	cbz w0, loop
	

	mov	x0, x20			// Get the File pointer
	bl	fclose			// Close the file.
	
	ldp	x29, x30, [sp], 32

	ret
